require "piped/version"
require 'json'
require 'rest-client'
require 'hashie'

module Piped
  REQUEST_TIMEOUT = 60
  OPEN_TIMEOUT = 5
  @@api_key = "SET_YOUR_API_KEY"
  @@piped_host = nil # Optional

  def self.api_key=(key)
    @@api_key = key
  end

  def self.pipeman_host=(host)
    @@pipeman_host = host
  end

  def self.pipeman_host
    @@pipeman_host ||= "https://pipeman.edmodo.com"
  end

  # See https://github.com/edmodo/pipeman#create-events-using-events-api
  def self.push(options={})
    api_key = options.delete(:api_key) || @@api_key
    host = options.delete(:pipeman_host) || self.pipeman_host

    response = RestClient::Request.execute(
      method: :post,
      url: "#{host}/events",
      payload: JSON.generate(options),
      headers: {"Authorization" => "Bearer #{api_key}", :content_type => :json, :accept => :json},
      timeout: REQUEST_TIMEOUT,
      open_timeout: OPEN_TIMEOUT
    )

    Hashie::Mash.new(JSON.parse(response))
  end
end
